[package]
name = "mathru"
version = "0.8.4"
description = "Mathematics library written in Rust"
authors = ["Matthias Eiholzer <matthias.eiholzer@gmail.com>"]
exclude = ["literature/*", "tests/*", "backup/*", ".gitignore"]
keywords = ["optimization", "statistics", "algebra", "matrix", "ode"]
categories = ["mathematics", "science", "algorithms"]
readme = "README.md"
license = "MIT"
homepage = "https://matthiaseiholzer.gitlab.io/mathru"
repository = "https://gitlab.com/matthiaseiholzer/mathru"
documentation = "https://docs.rs/crate/mathru/latest/"
autobenches = false
edition = "2018"


[package.metadata.docs.rs]
rustdoc-args = [
    "--html-in-header",
    "katex.html",
]

[lib]
name = "mathru"
path = "src/lib.rs"

[features]
default = ["native"]
native = []
blaslapack = []
serde-serialize = ["serde"]

openblas = ["lapack", "blas", "lapack-src/openblas", "blas-src/openblas", "blaslapack"]
netlib = ["lapack", "blas", "lapack-src/netlib", "blas-src/netlib", "blaslapack"]
accelerate = ["lapack", "blas", "lapack-src/accelerate", "blas-src/accelerate", "blaslapack"]
intel-mkl = ["lapack", "blas", "lapack-src/intel-mkl", "blas-src/intel-mkl", "blaslapack"]


[profile.dev]
opt-level = 0
debug = true

[profile.release]
opt-level = 3
debug = false
lto = true

[profile.test]
opt-level = 0
debug = true

[profile.bench]
opt-level = 3
debug = false

[dependencies]

[dependencies.rand]
version = "0.8"

[dependencies.serde]
version =  "1.0"
features = ["derive"]
optional = true

[dependencies.lapack]
version = "0.16"
optional = true

[dependencies.blas]
version = "0.20"
optional = true

[dependencies.blas-src]
version = "0.7"
optional = true

[dependencies.lapack-src]
version = "0.6"
optional = true

[dev-dependencies.serde_json]
version = "1.0"

[dev-dependencies.criterion]
version = "^0.3"

[dev-dependencies.nalgebra]
version = "0.23"

[dev-dependencies.plotters]
version = "0.3"

[[bench]]
name = "benchmark"
path = "benches/lib.rs"
harness = false


